Attribute VB_Name = "tmconn"
Const TM_STATUS = &H8000
Const TM_ANALOG = &H8001

Private Type TAnalogPoint
    asFloat As Single
    asCode  As Integer
    Flags   As Integer
    Unit    As String * 8
End Type

#If Win64 Then
Private Declare PtrSafe Function cfsInitLibrary Lib "libif_cfs.dll" _
        (ByVal base_dir As String, ByVal ext_arg As String) As Long

Private Declare PtrSafe Sub cfsSetUser Lib "libif_cfs.dll" _
        (ByVal name As String, ByVal pwd As String)

Private Declare PtrSafe Function tmcConnect Lib "libif_cfs.dll" _
        (ByVal ServName As String, ByVal PipeName As String, ByVal LocName As String, _
        ByVal cback As Long, ByVal cback_param As Long) As Long
        
Private Declare PtrSafe Sub tmcDisconnect Lib "libif_cfs.dll" _
        (ByVal hConn As Long)
               
Private Declare PtrSafe Function tmcEvaluateExpression Lib "libif_cfs.dll" _
        (ByVal cid As Long, ByVal expr As String, ByVal res As String, ByVal cbytes As Long) As Integer

Private Declare PtrSafe Function tmcSetAnalog Lib "libif_cfs.dll" _
        (ByVal cid As Long, ByVal Ch As Integer, ByVal RTU As Integer, ByVal Point As Integer, ByVal Value As Single, ByVal Time As String) As Integer
        
Private Declare PtrSafe Function tmcSetStatus Lib "libif_cfs.dll" _
        (ByVal cid As Long, ByVal Ch As Integer, ByVal RTU As Integer, ByVal Point As Integer, ByVal Value As Byte, ByVal Time As String, ByVal Hund As Integer) As Integer
        
Private Declare PtrSafe Function tmcGetObjectName Lib "libif_cfs.dll" _
        (ByVal cid As Long, ByVal ObjType As Integer, ByVal Ch As Integer, ByVal RTU As Integer, ByVal Point As Integer, ByVal res As String, ByVal cbytes As Long) As Integer
        
Private Declare PtrSafe Function tmcAnalogFull Lib "libif_cfs.dll" _
        (ByVal cid As Long, ByVal Ch As Long, ByVal RTU As Long, ByVal Point As Long, ByRef AP As TAnalogPoint, ByVal DT As Integer, ByVal Num As Long) As Integer

#Else
Private Declare Sub cfsSetUser Lib "cfshare.dll" _
        (ByVal name As String, ByVal pwd As String)

Private Declare Function tmcConnect Lib "tmconn.dll" Alias "_tmcConnect@20" _
        (ByVal ServName As String, ByVal PipeName As String, ByVal LocName As String, _
        ByVal cback As Long, ByVal cback_param As Long) As Long
        
Private Declare Sub tmcDisconnect Lib "tmconn.dll" Alias "_tmcDisconnect@4" _
        (ByVal hConn As Long)
               
Private Declare Function tmcEvaluateExpression Lib "tmconn.dll" Alias "_tmcEvaluateExpression@16" _
        (ByVal cid As Long, ByVal expr As String, ByVal res As String, ByVal cbytes As Long) As Integer

Private Declare Function tmcSetAnalog Lib "tmconn.dll" Alias "_tmcSetAnalog@24" _
        (ByVal cid As Long, ByVal Ch As Integer, ByVal Rtu As Integer, ByVal Point As Integer, ByVal Value As Single, ByVal Time As String) As Integer
        
Private Declare Function tmcSetStatus Lib "tmconn.dll" Alias "_tmcSetStatus@28" _
        (ByVal cid As Long, ByVal Ch As Integer, ByVal Rtu As Integer, ByVal Point As Integer, ByVal Value As Byte, ByVal Time As String, ByVal Hund As Integer) As Integer

Private Declare Function tmcGetObjectName Lib "tmconn.dll" Alias "_tmcGetObjectName@28" _
        (ByVal cid As Long, ByVal ObjType As Integer, ByVal Ch As Integer, ByVal RTU As Integer, ByVal Point As Integer, ByVal res As String, ByVal cbytes As Long) As Integer

Private Declare Function tmcAnalogFull Lib "tmconn.dll" Alias "_tmcAnalogFull@28" _
        (ByVal cid As Long, ByVal Ch As Long, ByVal RTU As Long, ByVal Point As Long, ByRef AP As TAnalogPoint, ByVal DT As Integer, ByVal Num As Long) As Integer
#End If

Sub OIK_recalc()

Dim hConn, retcode As Long
Dim Server, s_parsed, User, Password, expr, t, addr, val As String
Dim res As String * 256
Dim Ch, RTU, Point, retval As Integer
Dim sVal As Single
Dim bVal As Byte
Dim bRetCode As Long
Dim AP As TAnalogPoint

#If Win64 Then
bRetCode = cfsInitLibrary(0, 0)
#End If

On Error Resume Next
User = Evaluate(ActiveWorkbook.Names("OIK_User").Value)
Password = Evaluate(ActiveWorkbook.Names("OIK_Password").Value)
If (User <> "") And (Password <> "") Then
    Call cfsSetUser(User, Password)
End If
Server = Evaluate(ActiveWorkbook.Names("OIK_Server").Value)

If (User = "") And (Password = "") And (Server = "") Then
    Call ActiveWorkbook.Names.Add("OIK_User", " ", True)
    Call ActiveWorkbook.Names.Add("OIK_Password", " ", True)
    Call ActiveWorkbook.Names.Add("OIK_Server", " ", True)
End If

If InStr(1, Server, "{") > 1 Then
    hConn = tmcConnect("", Server, "ExcelCalc", 0, 0)
  Else
    s_parsed = Split(Server, "\")
    hConn = tmcConnect(s_parsed(0), s_parsed(1), "ExcelCalc", 0, 0)
End If
Application.ScreenUpdating = False
For Each Sheet In ActiveWorkbook.Sheets
    For Each Cell In Sheet.UsedRange.Cells
        If Not (Cell.Comment Is Nothing) Then
            expr = Cell.Comment.Text
            res = ""
            If InStr(1, expr, "<") Then
                '       
                expr = Right(expr, Len(expr) - 1)
                retcode = tmcEvaluateExpression(hConn, expr, res, 255)
                Cell.Value = res
            ElseIf Left(expr, 3) = ">#T" Then
                '      
                val = Cell.Text
                addr = Right(expr, Len(expr) - 4) ' cut >#TT or >#TC
                adr_elems = Split(addr, ":")
                If UBound(adr_elems) >= 2 Then
                    Ch = adr_elems(0)
                    RTU = adr_elems(1)
                    Point = adr_elems(2)
                    If Left(expr, 4) = ">#TT" Then
                       sVal = val
                       On Error GoTo Skip
                       retval = tmcSetAnalog(hConn, Ch, RTU, Point, sVal, "")
                    ElseIf Left(expr, 4) = ">#TC" Then
                       bVal = val
                       On Error GoTo Skip
                       retval = tmcSetStatus(hConn, Ch, RTU, Point, bVal, "", 0)
                    End If
                End If
            End If
        End If
Skip:
    Next
Next
For Each nm In ActiveWorkbook.Names
    expr = nm.name
    res = ""
    t = Left(expr, 2)
    If (t = "TT") Or (t = "TC") Then
        addr = Right(expr, Len(expr) - 2) ' cut TT or TC
        adr_elems = Split(addr, ".")
        If UBound(adr_elems) >= 2 Then
            Ch = adr_elems(0)
            RTU = adr_elems(1)
            Point = adr_elems(2)
            If UBound(adr_elems) = 2 Then
                '  
                retcode = tmcEvaluateExpression(hConn, "#" & t & Ch & ":" & RTU & ":" & Point, res, 255)
            ElseIf UBound(adr_elems) = 3 Then
                If adr_elems(3) = "name" Then
                    '  
                    If t = "TT" Then
                        retcode = tmcGetObjectName(hConn, TM_ANALOG, Ch, RTU, Point, res, 255)
                    ElseIf t = "TC" Then
                        retcode = tmcGetObjectName(hConn, TM_STATUS, Ch, RTU, Point, res, 255)
                    End If
                ElseIf (adr_elems(3) = "unit") And (t = "TT") Then
                    '   
                    AP.Unit = ""
                    retcode = tmcAnalogFull(hConn, Ch, RTU, Point, AP, 0, 0)
                    res = AP.Unit
                End If
            End If
            nm.RefersToRange.Cells(1).Value = res
        End If
    End If
Skip2:
Next
Call tmcDisconnect(hConn)
Application.ScreenUpdating = True
End Sub





